// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hidehisa AKIYAMA

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef BHV_OPUCI_SET_PLAY_H
#define BHV_OPUCI_SET_PLAY_H

#include <rcsc/geom/vector_2d.h>
#include <rcsc/player/soccer_action.h>
#include <vector>

class Bhv_OpuciSetPlay
    : public rcsc::SoccerBehavior {
public:
    Bhv_OpuciSetPlay()
      {}

    bool execute( rcsc::PlayerAgent * agent );

private:
    bool isKicker( rcsc::PlayerAgent * agent );
    bool doKickerAction( rcsc::PlayerAgent * agent );
    bool goToBall( rcsc::PlayerAgent * agent );
    bool doPositioning( rcsc::PlayerAgent * agent );
    bool setMovePos( rcsc::PlayerAgent * agent, 
                     std::vector< rcsc::Vector2D > & candidates );
    rcsc::Vector2D getPosition( rcsc::PlayerAgent * agent );

};

#endif
