// -*-c++-*-

/*
 *Copyright:

 Copyright (C) Hidehisa AKIYAMA

 This code is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This code is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this code; see the file COPYING.  If not, write to
 the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

 *EndCopyright:
 */

/////////////////////////////////////////////////////////////////////

#ifndef AGENT2D_ROLE_ROKURO_H
#define AGENT2D_ROLE_ROKURO_H

#include "soccer_role.h"

class RoleRokuro
    : public SoccerRole {
private:

public:

    static const std::string NAME;

    RoleRokuro()
      { }

    ~RoleRokuro()
      { }

    virtual
    void execute( rcsc::PlayerAgent * agent );


    static
    const
    std::string & name()
      {
          return NAME;
      }

    static
    SoccerRole::Ptr create()
      {
          SoccerRole::Ptr ptr( new RoleRokuro() );
          return ptr;
      }

private:

    void doKick( rcsc::PlayerAgent * agent );
    void doOffensiveKick( rcsc::PlayerAgent * agent );
    bool doDirectPass( rcsc::PlayerAgent * agent, int target_unum );
    bool doThroughPass( rcsc::PlayerAgent * agent, int target_unum );
    void doMove( rcsc::PlayerAgent * agent );

    static int M_passMate;
    static int M_neck_cnt;
};


#endif
